// FamilyCode10Servlet.java - A demo servlet based on iButtonContainer10.
//
// Copyright (C) 1999,2000  Smart Software Consulting
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Smart Software Consulting
// 1688 Silverwood Court
// Danville, CA  94526-3079
// USA
//
// http://www.smartsc.com
//

import java.io.*;
import java.util.Enumeration;
import java.util.Vector;

import javax.servlet.*;
import javax.servlet.http.*;

import com.ibutton.iButtonException;
import com.ibutton.adapter.DSPortAdapter;
import com.ibutton.container.iButtonContainer;
import com.ibutton.container.iButtonContainer10;
import com.ibutton.utils.Address;

public class FamilyCode10Servlet
extends HttpServlet
{
	public void doGet( HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
		String adapter = req.getParameter( iButtonServlet.ADAPTER);
		String port = req.getParameter( iButtonServlet.PORT);
		String ibString = req.getParameter( iButtonServlet.IBUTTON);

		if( adapter  == null || port == null
		||  ibString == null || ibString.length() != 16)
		{
			throw new ServletException(
				getClass().getName() + ": Invalid parameters.");
		}

		byte[] id = Address.toByteArray( ibString);

		// Do HTTP header stuff
		res.setContentType( "text/html");

		// Get Writer
		PrintWriter pw = res.getWriter();

		// Start HTML
		pw.println( "<html>");
		pw.println( "<head><title>Temperature iButton Servlet</title></head>");
		pw.println( "<body>");


		DSPortAdapter pa = null;
		try
		{
			pa = iButtonServlet.getAdapter( adapter, port);
			iButtonContainer10 ib = new iButtonContainer10();
			ib.setupContainer( pa, id);
			sendBody( pw, pa, ib);
		}
		catch( Exception e)
		{
			iButtonServlet.sendAlert( pw, e);
			pw.println( "<P>Error: " + e.getMessage());
		}

		// Finish HTML
		pw.println("</body></html>");
	}

	public void sendBody(
		PrintWriter pw, DSPortAdapter pa, iButtonContainer10 ib)
	throws iButtonException
	{
		if( ib.isPresent())
		{
			pw.print( "<H1>Current Temperature of iButton ");
			pw.print( ib.getAddressAsString());
			pw.println( "</H1>");
			float cTemp = ib.readTemperature();
			pw.print( "<H2>");
			pw.print( String.valueOf( cTemp));
			pw.print( " &deg;C (");
			pw.print( String.valueOf( ib.convertToFahrenheit( cTemp)));
			pw.print( " &deg;F)</H2>");
		}
		else
		{
			pw.println( "<H1>iButton Not Found</H1>");
			pw.print( "iButton ");
			pw.print( ib.getAddressAsString());
			pw.print( " is not present on adapter '");
			pw.print( pa.getAdapterName());
			pw.print( "' on port '");
			pw.print( pa.getPortName());
			pw.println( "'.");
		}
	}
}
