// SessionServlet.java - A simple servlet that uses HttpSession.
//
// Copyright (C) 1999,2000  Smart Software Consulting
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Smart Software Consulting
// 1688 Silverwood Court
// Danville, CA  94526-3079
// USA
// 
// http://www.smartsc.com
//

import java.io.*;
import java.util.Enumeration;

import javax.servlet.*;
import javax.servlet.http.*;

public class SessionServlet
extends HttpServlet
{
	public void doPost( HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
		doGet( req, res);
	}

	public void doGet( HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
		HttpSession session = req.getSession();

		res.setContentType( "text/html");
		PrintWriter out = res.getWriter();

		out.println(
			"<HTML><HEAD><TITLE> " +
			"SessionServlet Output " +
			"</TITLE></HEAD><BODY>" + 
			"<h1> SessionServlet Output </h1>");


		Integer i = (Integer)session.getValue( COUNTER_KEY);
		if( i == null)
		{
			i = new Integer( 1);
		}
		else
		{
			i = new Integer( i.intValue() + 1);
		}

		session.putValue( COUNTER_KEY, i);
		out.println( "You have hit this page <b>" + i + "</b> times.<p>");
		out.println(
			"Click <a href=" +
			res.encodeURL( req.getServletPath()) +
			">here</a> ");
		out.println(
			"to ensure that session tracking is working even " +
			"if cookies are not supported.<br>");
		
		out.println(
			"Note that by default URL rewriting is not enabled " +
			"due to its expensive overhead");
		out.println( "<p>");
		
		out.println( "<h3>Request and Session Data:</h3>");
		out.println( "Session ID in Request: " +
			req.getRequestedSessionId());
		out.println( "<br>Session ID in Request from Cookie: " +
			req.isRequestedSessionIdFromCookie());
		out.println( "<br>Session ID in Request from URL: " +
			req.isRequestedSessionIdFromURL());
		out.println( "<br>Valid Session ID: " +
			req.isRequestedSessionIdValid());
		out.println( "<h3>Session Data:</h3>");
		out.println( "New Session: " + session.isNew());
		out.println( "<br>Session ID: " + session.getId());

		out.println( "<br>Creation Time: " +
			session.getCreationTime());
		out.println( "<br>Last Accessed Time: " +
			session.getLastAccessedTime());

		out.println( "</BODY></HTML>");
		out.close();
	}

	public String getServletInfo()
	{
		return "A simple servlet";
	}
	
	public static String COUNTER_KEY = "SessionServlet.counter";
}
