// HttpReasonPhrases.java - Defines common HTTP reason phrases.
//
// Copyright (C) 1999,2000  Smart Software Consulting
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Smart Software Consulting
// 1688 Silverwood Court
// Danville, CA  94526-3079
// USA
// 
// http://www.smartsc.com
//

package com.smartsc.http;

public interface
HttpReasonPhrases
{
	public static final String RP_CONTINUE =
	                             "Continue";
	public static final String RP_SWITCHING_PROTOCOLS =
	                             "Switching Protocols";
	public static final String RP_OK =
	                             "OK";
	public static final String RP_CREATED =
	                             "Created";
	public static final String RP_ACCEPTED =
	                             "Accepted";
	public static final String RP_NON_AUTHORITATIVE_INFORMATION =
	                             "Non-Authoritative Information";
	public static final String RP_NO_CONTENT =
	                             "No Content";
	public static final String RP_RESET_CONTENT =
	                             "Reset Content";
	public static final String RP_PARTIAL_CONTENT =
	                             "Partial Content";
	public static final String RP_MULTIPLE_CHOICES =
	                             "Multiple Choices";
	public static final String RP_MOVED_PERMANENTLY =
	                             "Moved Permanently";
	public static final String RP_FOUND =
	                             "Found";
	public static final String RP_SEE_OTHER =
	                             "See Other";
	public static final String RP_NOT_MODIFIED =
	                             "Not Modified";
	public static final String RP_USE_PROXY =
	                             "Use Proxy";
	public static final String RP_TEMPORARY_REDIRECT =
	                             "Temporary Redirect";
	public static final String RP_BAD_REQUEST =
	                             "Bad Request";
	public static final String RP_UNAUTHORIZED =
	                             "Unauthorized";
	public static final String RP_PAYMENT_REQUIRED =
	                             "Payment Required";
	public static final String RP_FORBIDDEN =
	                             "Forbidden";
	public static final String RP_NOT_FOUND =
	                             "Not Found";
	public static final String RP_METHOD_NOT_ALLOWED =
	                             "Method Not Allowed";
	public static final String RP_NOT_ACCEPTABLE =
	                             "Not Acceptable";
	public static final String RP_PROXY_AUTHENTICATION_REQUIRED =
	                             "Proxy Authentication Required";
	public static final String RP_REQUEST_TIMEOUT =
	                             "Request Time-out";
	public static final String RP_CONFLICT =
	                             "Conflict";
	public static final String RP_GONE =
	                             "Gone";
	public static final String RP_LENGTH_REQUIRED =
	                             "Length Required";
	public static final String RP_PRECONDITION_FAILED =
	                             "Precondition Failed";
	public static final String RP_REQUEST_ENTITY_TOO_LARGE =
	                             "Request Entity Too Large";
	public static final String RP_REQUEST_URI_TOO_LARGE =
	                             "Request-URI Too Large";
	public static final String RP_UNSUPPORTED_MEDIA_TYPE =
	                             "Unsupported Media Type";
	public static final String RP_REQUESTED_RANGE_NOT_SATISFIABLE =
	                             "Requested range not satisfiable";
	public static final String RP_EXPECTATION_FAILED =
	                             "Expectation Failed";
	public static final String RP_INTERNAL_SERVER_ERROR =
	                             "Internal Server Error";
	public static final String RP_NOT_IMPLEMENTED =
	                             "Not Implemented";
	public static final String RP_BAD_GATEWAY =
	                             "Bad Gateway";
	public static final String RP_SERVICE_UNAVAILABLE =
	                             "Service Unavailable";
	public static final String RP_GATEWAY_TIME_OUT =
	                             "Gateway Time-out";
	public static final String RP_HTTP_VERSION_NOT_SUPPORTED =
	                             "HTTP Version not supported";
}
