// RequestDispatcher.java - Implements javax.servlet.RequestDispatcher.
//
// Copyright (C) 1999,2000  Smart Software Consulting
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Smart Software Consulting
// 1688 Silverwood Court
// Danville, CA  94526-3079
// USA
// 
// http://www.smartsc.com
//

package com.smartsc.http;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import com.smartsc.http.HttpRequest;
import com.smartsc.http.HttpResponse;

public class
RequestDispatcher
implements javax.servlet.RequestDispatcher
{
	protected
	RequestDispatcher( Servlet servlet, String urlPath)
	{
		this.servlet = servlet;
		this.urlPath = urlPath;
	}
	
	public void forward( ServletRequest req, ServletResponse res)
	throws ServletException, IOException
	{
		if( !(res instanceof HttpResponse) )
			throw new IllegalArgumentException();
			
		HttpResponse httpRes = (HttpResponse)res;
		
		if( httpRes.getHeaderSent())
			throw new IllegalStateException( "Header already sent.");
		
		include( req, res);
	}
	
	public void include( ServletRequest req, ServletResponse res)
	throws ServletException, IOException
	{
		if( !(req instanceof HttpRequest) )
			throw new IllegalArgumentException();
		
		HttpRequest httpReq = (HttpRequest)req;

		httpReq.setRequestPath( urlPath);
		
		servlet.service( req, res);
	}
	
	private Servlet servlet;
	private String urlPath;
}
