package com.smartsc.ibutton;

import java.util.Enumeration;

import com.ibutton.iButtonAccessProvider;
import com.ibutton.iButtonException;
import com.ibutton.adapter.DSPortAdapter;

public class PortAdapterEnumerator
{
	public interface Callback
	{
		public void forEachPortAdapter( DSPortAdapter pa, String p);
	}

	public static int enumerate( PortAdapterEnumerator.Callback callback)
	{
		int portAdapterCount = 0;

		Enumeration paEnum = iButtonAccessProvider.enumerateAllAdapters();

		while( paEnum.hasMoreElements())
		{
			DSPortAdapter pa = (DSPortAdapter)paEnum.nextElement();
			Enumeration pEnum = pa.getPortNames();
			while( pEnum.hasMoreElements())
			{
				String p = (String)pEnum.nextElement();
				try
				{
					if( pa.selectPort( p) && pa.adapterDetected())
					{
						callback.forEachPortAdapter( pa, p);
						++portAdapterCount;
					}
				}
				catch( iButtonException ibe) {}
			}
		}

		return portAdapterCount;
	}
}